diff -ruN uppsrc/ide/LayDes/laydes.cpp uppsrc/ide/LayDes/laydes.cpp
--- uppsrc/ide/LayDes/laydes.cpp	2013-09-02 20:47:56 +0400
+++ uppsrc/ide/LayDes/laydes.cpp	2013-09-02 23:18:36 +0400
@@ -1254,46 +1254,41 @@
 
 bool RectLess(const Rect& a, const Rect& b)
 {
-	return max(a.top, b.top) < min(a.bottom, b.bottom) ? a.left < b.left : a.top < b.top;
+	if(a.top < b.top)
+		return true;
+	if(a.top == b.top)
+		return a.left < b.left;
+	return false;
 }
 
 void LayDes::SortItems()
 {
 	SaveState();
-	if(currentlayout < 0 || cursor.GetCount() < 2)
+	int count = cursor.GetCount();
+	if(currentlayout < 0 || count < 2)
 		return;
 	LayoutData& l = CurrentLayout();
-
-	Sort(cursor);
-	int count = cursor.GetCount();
-
 	Array<LayoutItem> item;
+	item.SetCount(count);
 	Vector<Rect> rect;
+	rect.SetCount(count);
+	Vector<int> order;
+	order <<= cursor;
 	for(int i = 0; i < count; ++i) {
-		rect.Add(CtrlRect(l.item[cursor[i]].pos, l.size));
-		item.Add() = l.item[cursor[i]];
+		rect[i] = CtrlRect(l.item[cursor[i]].pos, l.size);
+		item[i] = l.item[cursor[i]];
 	}
+	IndexSort2(rect, order, item, &RectLess);
+	int q = FindIndex(order, cursor.Top());
+	Sort(cursor);
 	l.item.Remove(cursor);
-
-	bool swap = false;
-	do {
-		swap = false;
-		for(int i = 0; i < count - 1; i++)
-			if(RectLess(rect[i + 1], rect[i])) {
-				Swap(rect[i], rect[i + 1]);
-				Swap(item[i], item[i + 1]);
-				swap = true;
-			}
-	}
-	while(swap);
-	
 	int ii = cursor[0];
 	l.item.InsertPick(ii, item);
-	
 	cursor.Clear();
-	for(int i = 0; i < count; i++)
+	for(int i = 0; i < count; ++i)
 		cursor.Add(i + ii);
-
+	if(q >= 0 && q != count - 1)
+		Swap(cursor.Top(), cursor[q]);
 	ReloadItems();
 }
 
@@ -1489,9 +1484,18 @@
 		}
 	}
 	else if(item.IsCursor()) {
-		if(!GetCtrl())
+		int c = item.GetCursor();
+		if(!GetCtrl()) {
 			cursor.Clear();
-		cursor.Add(item.GetCursor());
+			cursor.Add(c);
+		}
+		else {
+			int q = FindIndex(cursor, c);
+			if(q >= 0)
+				cursor.Remove(q);
+			else
+				cursor.Add(c);
+		}
 	}
 	SetFocus();
 	SyncItems();
